// 同步模块，配置发射功率
// 杭州秒寻科技有限公司
// 周涛
// 2023-11-20
// 注意：这部分代码为厂家提供，没做修改

#include "includes.h"

const unsigned char g_cmt2310a_13dBm_matching_tx_pwr_tbl[4][24][3];
const unsigned char g_cmt2310a_20dBm_matching_tx_pwr_tbl[4][31][3];

//
//                                         Target_TX_Power + RADIO_TX_POWER_OFFSET_LABEL
//                                         ---------------------------------------------
//                                                          |
//                                                          |
//                                                          |
//   0 = 113MHz<Fc<=340MHz -----------+------------------+  |   +--------------page1_address, 0x1E, 0x1F, 0x24
//   1 = 340MHz<Fc<=510MHz -----------|                  |  |   |
//   2 = 510MHz<Fc<=870MHz -----------|                  |  |   |
//   3 = 870MHz<Fc<=960MHz -----------|                  |  |   |
//                                                       |  |   |
//                                                       |  |   |
const unsigned char g_cmt2310a_13dBm_matching_tx_pwr_tbl[4][24][3] = {
    {{30, (0 + 16), 1},
     {34, (0 + 16), 1},
     {39, (0 + 16), 1},
     {42, (0 + 16), 2},
     {47, (0 + 16), 2},
     {53, (0 + 16), 2},
     {20, (0 + 25), 1},
     {23, (0 + 25), 1},
     {26, (0 + 25), 1},
     {29, (0 + 25), 1},
     {33, (0 + 25), 1},
     {38, (0 + 25), 1},
     {43, (0 + 25), 1},
     {49, (0 + 25), 1},
     {56, (0 + 25), 1},
     {63, (0 + 25), 2},
     {70, (0 + 25), 2},
     {79, (0 + 25), 2},
     {87, (0 + 25), 3},
     {97, (0 + 25), 3},
     {112, (0 + 25), 3},
     {48, (0 + 45), 5},
     {53, (0 + 45), 6},
     {63, (0 + 45), 7}},
    //-------------------
    {{25, (0 + 18), 1},
     {28, (0 + 18), 1},
     {32, (0 + 18), 1},
     {37, (0 + 18), 1},
     {41, (0 + 18), 2},
     {47, (0 + 18), 2},
     {53, (0 + 18), 2},
     {22, (0 + 27), 1},
     {25, (0 + 27), 1},
     {28, (0 + 27), 1},
     {32, (0 + 27), 1},
     {37, (0 + 27), 1},
     {42, (0 + 27), 1},
     {48, (0 + 27), 1},
     {53, (0 + 27), 1},
     {58, (0 + 27), 2},
     {65, (0 + 27), 2},
     {72, (0 + 27), 2},
     {80, (0 + 27), 3},
     {91, (0 + 27), 4},
     {104, (0 + 27), 5},
     {54, (0 + 45), 7},
     {64, (0 + 45), 8},
     {77, (0 + 45), 12}},
    //-------------------
    {{32, (0 + 18), 1},
     {36, (0 + 18), 1},
     {41, (0 + 18), 1},
     {43, (0 + 18), 2},
     {50, (0 + 18), 2},
     {60, (0 + 18), 2},
     {65, (0 + 18), 2},
     {26, (0 + 27), 1},
     {29, (0 + 27), 1},
     {33, (0 + 27), 1},
     {39, (0 + 27), 1},
     {45, (0 + 27), 1},
     {51, (0 + 27), 1},
     {58, (0 + 27), 1},
     {63, (0 + 27), 2},
     {69, (0 + 27), 2},
     {78, (0 + 27), 2},
     {88, (0 + 27), 2},
     {30, (0 + 63), 4},
     {35, (0 + 63), 5},
     {40, (0 + 63), 5},
     {45, (0 + 63), 7},
     {57, (0 + 63), 10},
     {70, (0 + 63), 16}},
    //--------------------
    {{22, (0 + 19), 1},
     {25, (0 + 19), 1},
     {29, (0 + 19), 1},
     {34, (0 + 19), 1},
     {38, (0 + 19), 1},
     {43, (0 + 19), 1},
     {47, (0 + 19), 1},
     {23, (0 + 27), 1},
     {26, (0 + 27), 1},
     {30, (0 + 27), 1},
     {34, (0 + 27), 1},
     {40, (0 + 27), 1},
     {46, (0 + 27), 1},
     {51, (0 + 27), 1},
     {57, (0 + 27), 1},
     {62, (0 + 27), 2},
     {68, (0 + 27), 2},
     {80, (0 + 27), 2},
     {30, (0 + 63), 3},
     {35, (0 + 63), 4},
     {40, (0 + 63), 5},
     {45, (0 + 63), 7},
     {57, (0 + 63), 10},
     {67, (0 + 63), 15}},
};

//
//                                         Target_TX_Power + RADIO_TX_POWER_OFFSET_LABEL
//                                         ---------------------------------------------
//                                                          |
//                                                          |
//                                                          |
//   0 = 113MHz<Fc<=340MHz -----------+------------------+  |   +--------------page1_address, 0x1E, 0x1F, 0x24
//   1 = 340MHz<Fc<=510MHz -----------|                  |  |   |
//   2 = 510MHz<Fc<=870MHz -----------|                  |  |   |
//   3 = 870MHz<Fc<=960MHz -----------|                  |  |   |
//                                                       |  |   |
//                                                       |  |   |
const unsigned char g_cmt2310a_20dBm_matching_tx_pwr_tbl[4][31][3] = {
    {{22, (0 + 22), 1},
     {22, (0 + 22), 1},
     {29, (0 + 22), 1},
     {32, (0 + 22), 1},
     {36, (0 + 22), 1},
     {41, (0 + 22), 1},
     {22, (0 + 31), 1},
     {25, (0 + 31), 1},
     {29, (0 + 31), 1},
     {32, (0 + 31), 1},
     {37, (0 + 31), 1},
     {43, (0 + 31), 1},
     {48, (0 + 31), 1},
     {54, (0 + 31), 1},
     {59, (0 + 31), 2},
     {67, (0 + 31), 2},
     {76, (0 + 31), 2},
     {86, (0 + 31), 2},
     {97, (0 + 31), 2},
     {107, (0 + 31), 3},
     {122, (0 + 31), 3},
     {139, (0 + 31), 4},
     {67, (0 + 63), 7},
     {76, (0 + 63), 9},
     {87, (0 + 63), 11},
     {103, (0 + 63), 12},
     {126, (0 + 63), 16},
     {81, (64 + 63), 17},
     {104, (64 + 63), 25},
     {140, (64 + 63), 31},
     {168, (64 + 63), 31}},
    //--------------------
    {{26, (0 + 22), 1},
     {29, (0 + 22), 1},
     {33, (0 + 22), 1},
     {37, (0 + 22), 1},
     {42, (0 + 22), 1},
     {48, (0 + 22), 1},
     {54, (0 + 22), 1},
     {29, (0 + 31), 1},
     {33, (0 + 31), 1},
     {37, (0 + 31), 1},
     {42, (0 + 31), 1},
     {47, (0 + 31), 1},
     {53, (0 + 31), 1},
     {60, (0 + 31), 1},
     {66, (0 + 31), 1},
     {73, (0 + 31), 2},
     {84, (0 + 31), 2},
     {95, (0 + 31), 3},
     {107, (0 + 31), 3},
     {51, (0 + 63), 5},
     {57, (0 + 63), 6},
     {64, (0 + 63), 7},
     {73, (0 + 63), 8},
     {83, (0 + 63), 10},
     {95, (0 + 63), 12},
     {112, (0 + 63), 15},
     {133, (0 + 63), 20},
     {80, (64 + 63), 18},
     {105, (64 + 63), 24},
     {128, (64 + 63), 28},
     {160, (64 + 63), 31}},
    //--------------------
    {{24, (0 + 21), 1},
     {28, (0 + 21), 1},
     {33, (0 + 21), 1},
     {37, (0 + 21), 1},
     {41, (0 + 21), 1},
     {47, (0 + 21), 1},
     {53, (0 + 21), 1},
     {24, (0 + 31), 1},
     {28, (0 + 31), 1},
     {31, (0 + 31), 1},
     {36, (0 + 31), 1},
     {41, (0 + 31), 1},
     {46, (0 + 31), 1},
     {53, (0 + 31), 1},
     {60, (0 + 31), 2},
     {67, (0 + 31), 2},
     {74, (0 + 31), 2},
     {82, (0 + 31), 3},
     {39, (0 + 63), 4},
     {44, (0 + 63), 5},
     {49, (0 + 63), 6},
     {55, (0 + 63), 7},
     {62, (0 + 63), 8},
     {71, (0 + 63), 9},
     {81, (0 + 63), 11},
     {93, (0 + 63), 12},
     {109, (0 + 63), 12},
     {78, (64 + 63), 13},
     {92, (64 + 63), 17},
     {120, (64 + 63), 24},
     {145, (64 + 63), 31}},
    //--------------------
    {{28, (0 + 22), 1},
     {31, (0 + 22), 1},
     {35, (0 + 22), 1},
     {39, (0 + 22), 2},
     {44, (0 + 22), 2},
     {24, (0 + 31), 1},
     {28, (0 + 31), 1},
     {31, (0 + 31), 1},
     {34, (0 + 31), 1},
     {40, (0 + 31), 1},
     {45, (0 + 31), 1},
     {51, (0 + 31), 1},
     {57, (0 + 31), 1},
     {64, (0 + 31), 1},
     {71, (0 + 31), 2},
     {81, (0 + 31), 2},
     {92, (0 + 31), 2},
     {103, (0 + 31), 3},
     {115, (0 + 31), 3},
     {131, (0 + 31), 3},
     {148, (0 + 31), 4},
     {71, (0 + 63), 7},
     {80, (0 + 63), 8},
     {90, (0 + 63), 9},
     {102, (0 + 63), 10},
     {118, (0 + 63), 13},
     {138, (0 + 63), 16},
     {79, (64 + 63), 13},
     {96, (64 + 63), 13},
     {116, (64 + 63), 16},
     {136, (64 + 63), 20}},
};

/******************************
**Name:  sync_power_config
**Func:  Radio set transmit power
**Input: match_sel: FALSE for 13dBm matching;   TRUE for 20dBm matching;
**       band_sel:  0 = 113MHz<Fc<=340MHz;
                    1 = 340MHz<Fc<=510MHz;
                    2 = 510MHz<Fc<=870MHz;
                    3 = 870MHz<Fc<=960MHz;
**       tx_pwr:    -10 to +13 in 13dBm matching;  -10 to +20 in 20dBm matching
*Output: None
**note:  Should be used in standby mode
**配置完成后，芯片在tfs状态，可立即发射
********************************/
void sync_power_config(BOOL match_sel, unsigned char band_sel, signed char tx_pwr)
{
    unsigned char pwr_sel;

    band_sel &= 0x03;

    // 切换芯片状态
    sync_switch_work_status(SYNC_STATUS_GO_SLEEP, SYNC_STATUS_SLEEP);
    sync_switch_work_status(SYNC_STATUS_GO_READY, SYNC_STATUS_READY);

    if (match_sel) // 20dBm matching
    {
        if (tx_pwr < (-10) || (tx_pwr > 20))
            return;
        tx_pwr += RADIO_TX_POWER_OFFSET_LABEL;
        pwr_sel = (unsigned char)tx_pwr;

        sync_select_reg_page(1);
        sync_wirte_reg(CMT2310A_TX_PWR_REG_00, g_cmt2310a_20dBm_matching_tx_pwr_tbl[band_sel][pwr_sel][0]);
        sync_wirte_reg(CMT2310A_TX_PWR_REG_01, g_cmt2310a_20dBm_matching_tx_pwr_tbl[band_sel][pwr_sel][1]);
        sync_wirte_reg(CMT2310A_TX_PWR_REG_06, g_cmt2310a_20dBm_matching_tx_pwr_tbl[band_sel][pwr_sel][2]);
        sync_select_reg_page(0);
    }
    else // 13dBm matching
    {
        if (tx_pwr < (-10) || (tx_pwr > 13))
            return;
        tx_pwr += RADIO_TX_POWER_OFFSET_LABEL;
        pwr_sel = (unsigned char)tx_pwr;
        sync_select_reg_page(1);
        sync_wirte_reg(CMT2310A_TX_PWR_REG_00, g_cmt2310a_13dBm_matching_tx_pwr_tbl[band_sel][pwr_sel][0]);
        sync_wirte_reg(CMT2310A_TX_PWR_REG_01, g_cmt2310a_13dBm_matching_tx_pwr_tbl[band_sel][pwr_sel][1]);
        sync_wirte_reg(CMT2310A_TX_PWR_REG_06, g_cmt2310a_13dBm_matching_tx_pwr_tbl[band_sel][pwr_sel][2]);
        sync_select_reg_page(0);
    }

    sync_switch_work_status(SYNC_STATUS_GO_TFS, SYNC_STATUS_TFS); // 切换到待发射状态

    return;
}

// 配置发送功率
// byPower:-10 to +20 in 20dBm matching，-10 to +13 in 13dBm matching
void sync_power_config_tx_power(int8 byPower)
{
    if (byPower < -10 || byPower > 20)
    {
        return;
    }

    // 配置发送功率
    sync_power_config(TRUE, 1, byPower);

    return;
}
