
#ifndef PUBLIC_H
#define PUBLIC_H

// 系统模块
typedef enum
{
    DRV_MODULE_HW = 0,    // 驱动硬件模块, 不进行细分
    SYS_MODULE_TIMER = 1, // 定时器管理模块
    APP_MODULE_NMC,       // 网管中心模块
    APP_MODULE_GUI,       // 本地网管模块
    APP_MODULE_SSM,       // 系统管理模块
    APP_MODULE_ALARM,     // 告警管理模块
    SYS_MODULE_MAX,       // 最大模块数
} SYS_MODULE_ID_E;

// 串口编号
typedef enum
{
    UART_GUI = 1, // 本地网管
    UART_WIFI,    // WiFi模块
    UART_RESERVE, // 保留
    UART_DEBUG,   // 调试接口
} SYS_UART_ID_E;

#endif
