// 蓝牙事件通知处理模块
// 杭州秒寻科技有限公司
// 周涛
// 2024-9-27

#ifndef __WIFI_BLE_EVENT_H__
#define __WIFI_BLE_EVENT_H__

#include "sysdef.h"

#define EVENT_WIFI_DISCONNECT "+EVENT:WIFI_DISCONNECT"
#define EVENT_WIFI_CONNECT "+EVENT:WIFI_CONNECT"
#define EVENT_SOCKET_DISCONNECT "+EVENT:SocketDisconnect"
#define EVENT_SOCKET_RECONNECT "+EVENT:SocketReconnect"

// 外部使用接口
void wifible_event_main(uint8 *pbyData);
uint8 wifible_event_get_tcp_connect_status();

#endif
